/* utils.c generated by valac 0.11.6, the Vala compiler
 * generated from utils.vala, do not modify */

/*
 * Copyright (C) 2010 Canonical Ltd
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by Mikkel Kamstrup Erlandsen <mikkel.kamstrup@canonical.com>
 *
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <unity.h>
#include <gee.h>
#include <dee.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define UNITY_APPLICATIONS_PLACE_TYPE_RESULTS_COLUMN (unity_applications_place_results_column_get_type ())

typedef enum  {
	UNITY_APPLICATIONS_PLACE_RESULTS_COLUMN_URI = 0,
	UNITY_APPLICATIONS_PLACE_RESULTS_COLUMN_ICON_HINT,
	UNITY_APPLICATIONS_PLACE_RESULTS_COLUMN_GROUP_ID,
	UNITY_APPLICATIONS_PLACE_RESULTS_COLUMN_MIMETYPE,
	UNITY_APPLICATIONS_PLACE_RESULTS_COLUMN_DISPLAY_NAME,
	UNITY_APPLICATIONS_PLACE_RESULTS_COLUMN_COMMENT
} UnityApplicationsPlaceResultsColumn;



GAppInfo* unity_applications_place_utils_get_app_info_for_actor (const gchar* actor);
gchar* unity_applications_place_utils_get_desktop_id_for_actor (const gchar* actor);
gboolean unity_applications_place_utils_check_actor_has_category (const gchar* actor, GeeSet* categories);
gboolean unity_applications_place_utils_search_has_really_changed (UnityPlaceSearch* old_search, UnityPlaceSearch* new_search);
void unity_applications_place_utils_apply_uri_filter (GeeSet* valid_uris, DeeResultSet* filter_set);
GType unity_applications_place_results_column_get_type (void) G_GNUC_CONST;


GAppInfo* unity_applications_place_utils_get_app_info_for_actor (const gchar* actor) {
	GAppInfo* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* desktop_id;
	UnityAppInfoManager* _tmp1_ = NULL;
	UnityAppInfoManager* _tmp2_;
	GAppInfo* _tmp3_ = NULL;
	GAppInfo* _tmp4_;
	g_return_val_if_fail (actor != NULL, NULL);
	_tmp0_ = unity_applications_place_utils_get_desktop_id_for_actor (actor);
	desktop_id = _tmp0_;
	_tmp1_ = unity_app_info_manager_get_instance ();
	_tmp2_ = _tmp1_;
	_tmp3_ = unity_app_info_manager_lookup (_tmp2_, desktop_id);
	result = (_tmp4_ = _tmp3_, _g_object_unref0 (_tmp2_), _tmp4_);
	_g_free0 (desktop_id);
	return result;
}


gboolean unity_applications_place_utils_check_actor_has_category (const gchar* actor, GeeSet* categories) {
	gboolean result = FALSE;
	UnityAppInfoManager* _tmp0_ = NULL;
	UnityAppInfoManager* appman;
	gchar* _tmp1_ = NULL;
	gchar* desktop_id;
	GAppInfo* _tmp2_ = NULL;
	GAppInfo* appinfo;
	gint _tmp3_;
	gchar** _tmp4_ = NULL;
	gchar** actor_cats;
	gint actor_cats_length1;
	gint _actor_cats_size_;
	g_return_val_if_fail (actor != NULL, FALSE);
	if (categories == NULL) {
		result = FALSE;
		return result;
	}
	_tmp0_ = unity_app_info_manager_get_instance ();
	appman = _tmp0_;
	_tmp1_ = unity_applications_place_utils_get_desktop_id_for_actor (actor);
	desktop_id = _tmp1_;
	_tmp2_ = unity_app_info_manager_lookup (appman, desktop_id);
	appinfo = _tmp2_;
	if (appinfo == NULL) {
		result = FALSE;
		_g_object_unref0 (appinfo);
		_g_free0 (desktop_id);
		_g_object_unref0 (appman);
		return result;
	}
	_tmp4_ = unity_app_info_manager_get_categories (appman, desktop_id, &_tmp3_);
	actor_cats = _tmp4_;
	actor_cats_length1 = _tmp3_;
	_actor_cats_size_ = _tmp3_;
	if (actor_cats == NULL) {
		result = FALSE;
		_g_object_unref0 (appinfo);
		_g_free0 (desktop_id);
		_g_object_unref0 (appman);
		return result;
	}
	{
		gchar** cat_collection;
		int cat_collection_length1;
		int cat_it;
		cat_collection = actor_cats;
		cat_collection_length1 = actor_cats_length1;
		for (cat_it = 0; cat_it < actor_cats_length1; cat_it = cat_it + 1) {
			gchar* _tmp5_;
			gchar* cat;
			_tmp5_ = g_strdup (cat_collection[cat_it]);
			cat = _tmp5_;
			{
				gboolean _tmp6_;
				_tmp6_ = gee_collection_contains ((GeeCollection*) categories, cat);
				if (_tmp6_) {
					result = TRUE;
					_g_free0 (cat);
					_g_object_unref0 (appinfo);
					_g_free0 (desktop_id);
					_g_object_unref0 (appman);
					return result;
				}
				_g_free0 (cat);
			}
		}
	}
	result = FALSE;
	_g_object_unref0 (appinfo);
	_g_free0 (desktop_id);
	_g_object_unref0 (appman);
	return result;
}


static gchar* string_substring (const gchar* self, glong offset, glong len) {
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	if (offset >= 0) {
		_tmp0_ = len >= 0;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		glong _tmp1_;
		_tmp1_ = strnlen ((gchar*) self, (gsize) (offset + len));
		string_length = _tmp1_;
	} else {
		gint _tmp2_;
		_tmp2_ = strlen (self);
		string_length = (glong) _tmp2_;
	}
	if (offset < 0) {
		offset = string_length + offset;
		g_return_val_if_fail (offset >= 0, NULL);
	} else {
		g_return_val_if_fail (offset <= string_length, NULL);
	}
	if (len < 0) {
		len = string_length - offset;
	}
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
	result = _tmp3_;
	return result;
}


gchar* unity_applications_place_utils_get_desktop_id_for_actor (const gchar* actor) {
	gchar* result = NULL;
	gboolean _tmp0_;
	gchar* _tmp13_;
	g_return_val_if_fail (actor != NULL, NULL);
	_tmp0_ = g_str_has_prefix (actor, "application://");
	if (_tmp0_) {
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_;
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_;
		_tmp1_ = string_substring (actor, (glong) 14, (glong) (-1));
		_tmp2_ = _tmp1_;
		_tmp3_ = g_strdup (_tmp2_);
		result = (_tmp4_ = _tmp3_, _g_free0 (_tmp2_), _tmp4_);
		return result;
	} else {
		gboolean _tmp5_;
		_tmp5_ = g_str_has_prefix (actor, "app://");
		if (_tmp5_) {
			gchar* _tmp6_ = NULL;
			gchar* _tmp7_;
			gchar* _tmp8_ = NULL;
			gchar* _tmp9_;
			_tmp6_ = string_substring (actor, (glong) 6, (glong) (-1));
			_tmp7_ = _tmp6_;
			_tmp8_ = g_strdup (_tmp7_);
			result = (_tmp9_ = _tmp8_, _g_free0 (_tmp7_), _tmp9_);
			return result;
		} else {
			gboolean _tmp10_;
			_tmp10_ = g_str_has_prefix (actor, "/");
			if (_tmp10_) {
				GFile* _tmp11_ = NULL;
				GFile* f;
				gchar* _tmp12_ = NULL;
				_tmp11_ = g_file_new_for_path (actor);
				f = _tmp11_;
				_tmp12_ = g_file_get_basename (f);
				result = _tmp12_;
				_g_object_unref0 (f);
				return result;
			}
		}
	}
	_tmp13_ = g_strdup (actor);
	result = _tmp13_;
	return result;
}


static gchar* string_strip (const gchar* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _result_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	g_strstrip (_result_);
	result = _result_;
	return result;
}


gboolean unity_applications_place_utils_search_has_really_changed (UnityPlaceSearch* old_search, UnityPlaceSearch* new_search) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gchar* s1 = NULL;
	gchar* s2 = NULL;
	if (old_search == NULL) {
		_tmp0_ = new_search == NULL;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		result = FALSE;
		return result;
	}
	if (old_search == NULL) {
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_;
		gboolean _tmp3_ = FALSE;
		_tmp1_ = unity_place_search_get_search_string (new_search);
		_tmp2_ = _tmp1_;
		_g_free0 (s1);
		s1 = _tmp2_;
		if (s1 == NULL) {
			_tmp3_ = TRUE;
		} else {
			gchar* _tmp4_ = NULL;
			gchar* _tmp5_;
			_tmp4_ = string_strip (s1);
			_tmp5_ = _tmp4_;
			_tmp3_ = g_strcmp0 (_tmp5_, "") == 0;
			_g_free0 (_tmp5_);
		}
		if (_tmp3_) {
			result = FALSE;
			_g_free0 (s2);
			_g_free0 (s1);
			return result;
		} else {
			result = TRUE;
			_g_free0 (s2);
			_g_free0 (s1);
			return result;
		}
	} else {
		if (new_search == NULL) {
			gchar* _tmp6_ = NULL;
			gchar* _tmp7_;
			gboolean _tmp8_ = FALSE;
			_tmp6_ = unity_place_search_get_search_string (old_search);
			_tmp7_ = _tmp6_;
			_g_free0 (s2);
			s2 = _tmp7_;
			if (s2 == NULL) {
				_tmp8_ = TRUE;
			} else {
				gchar* _tmp9_ = NULL;
				gchar* _tmp10_;
				_tmp9_ = string_strip (s2);
				_tmp10_ = _tmp9_;
				_tmp8_ = g_strcmp0 (_tmp10_, "") == 0;
				_g_free0 (_tmp10_);
			}
			if (_tmp8_) {
				result = FALSE;
				_g_free0 (s2);
				_g_free0 (s1);
				return result;
			} else {
				result = TRUE;
				_g_free0 (s2);
				_g_free0 (s1);
				return result;
			}
		} else {
			gchar* _tmp11_ = NULL;
			gchar* _tmp12_;
			gchar* _tmp13_ = NULL;
			gchar* _tmp14_;
			_tmp11_ = unity_place_search_get_search_string (new_search);
			_tmp12_ = _tmp11_;
			_g_free0 (s1);
			s1 = _tmp12_;
			_tmp13_ = unity_place_search_get_search_string (old_search);
			_tmp14_ = _tmp13_;
			_g_free0 (s2);
			s2 = _tmp14_;
			if (s1 == NULL) {
				gboolean _tmp15_ = FALSE;
				if (s2 == NULL) {
					_tmp15_ = TRUE;
				} else {
					gchar* _tmp16_ = NULL;
					gchar* _tmp17_;
					_tmp16_ = string_strip (s2);
					_tmp17_ = _tmp16_;
					_tmp15_ = g_strcmp0 (_tmp17_, "") == 0;
					_g_free0 (_tmp17_);
				}
				if (_tmp15_) {
					result = FALSE;
					_g_free0 (s2);
					_g_free0 (s1);
					return result;
				} else {
					result = TRUE;
					_g_free0 (s2);
					_g_free0 (s1);
					return result;
				}
			} else {
				if (s2 == NULL) {
					gboolean _tmp18_ = FALSE;
					if (s1 == NULL) {
						_tmp18_ = TRUE;
					} else {
						gchar* _tmp19_ = NULL;
						gchar* _tmp20_;
						_tmp19_ = string_strip (s1);
						_tmp20_ = _tmp19_;
						_tmp18_ = g_strcmp0 (_tmp20_, "") == 0;
						_g_free0 (_tmp20_);
					}
					if (_tmp18_) {
						result = FALSE;
						_g_free0 (s2);
						_g_free0 (s1);
						return result;
					} else {
						result = TRUE;
						_g_free0 (s2);
						_g_free0 (s1);
						return result;
					}
				} else {
					gchar* _tmp21_ = NULL;
					gchar* _tmp22_;
					gchar* _tmp23_ = NULL;
					gchar* _tmp24_;
					gboolean _tmp25_;
					_tmp21_ = string_strip (s1);
					_tmp22_ = _tmp21_;
					_tmp23_ = string_strip (s2);
					_tmp24_ = _tmp23_;
					result = (_tmp25_ = g_strcmp0 (_tmp22_, _tmp24_) != 0, _g_free0 (_tmp24_), _g_free0 (_tmp22_), _tmp25_);
					_g_free0 (s2);
					_g_free0 (s1);
					return result;
				}
			}
		}
	}
	_g_free0 (s2);
	_g_free0 (s1);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


void unity_applications_place_utils_apply_uri_filter (GeeSet* valid_uris, DeeResultSet* filter_set) {
	DeeModel* _tmp0_ = NULL;
	DeeModel* _tmp1_;
	DeeModel* model;
	guint n_removed;
	g_return_if_fail (valid_uris != NULL);
	g_return_if_fail (filter_set != NULL);
	_tmp0_ = dee_result_set_get_model (filter_set);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	model = _tmp1_;
	n_removed = (guint) 0;
	{
		DeeResultSet* _tmp2_ = NULL;
		DeeResultSet* _row_it;
		DeeModelIter* row = NULL;
		_tmp2_ = _vala_dee_result_set_iterator (filter_set);
		_row_it = _tmp2_;
		while (TRUE) {
			DeeModelIter* _tmp3_ = NULL;
			const gchar* _tmp4_ = NULL;
			gboolean _tmp5_;
			_tmp3_ = _vala_dee_result_set_next_value (_row_it);
			row = _tmp3_;
			if (!(row != NULL)) {
				break;
			}
			_tmp4_ = dee_model_get_string (model, row, (guint) UNITY_APPLICATIONS_PLACE_RESULTS_COLUMN_URI);
			_tmp5_ = gee_collection_contains ((GeeCollection*) valid_uris, _tmp4_);
			if (!_tmp5_) {
				dee_model_remove (model, row);
				n_removed++;
			}
		}
		_g_object_unref0 (_row_it);
	}
	g_debug ("utils.vala:142: Removed %u rows from result set", n_removed);
	_g_object_unref0 (model);
}



